/*************************************************************************
 * Copyright (c) 2004 Nick T Tate
 * 
 * This file is part of Tearless SDK.
 * 
 * Tearless SDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Tearless SDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Tearless SDK; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ************************************************************************/
/*
 * Header file for Tearless Camera library (Lib 12).
 *
 * Author: Nick T Tate 2003-09-07
 * 
 * $Id: tlcam.h 10 2004-10-21 08:18:24Z nicktt $
 */

#ifndef TEARLESS_CAM_HEADER
#define TEARLESS_CAM_HEADER

#include "tlcommon.h"

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack (push, 1);

// Camera lib
struct TearlessCamLib {
	UNK (TLCALL *func0)();
	UNK (TLCALL *func4)();
	UNK (TLCALL *func8)();
	UNK (TLCALL *funcC)();
	UNK (TLCALL *func10)();
	UNK (TLCALL *func14)();
	UNK (TLCALL *func18)();
	UNK (TLCALL *func1C)();
	UNK (TLCALL *func20)();
	UNK (TLCALL *func24)();
	UNK (TLCALL *func28)();
	UNK (TLCALL *func2C)();
	ERR (TLCALL *getCopyOfInfoStructs)(void* requestStruct);

	/*
	 * WARNING: This method overwrites important system areas,
	 * probably not directly to flash, but still dangerous.
	 */
	ERR (TLCALL *changeInfoStructs)(void* requestStruct);
	ERR (TLCALL *getExtraInfo)(void* extraInfoStruct);
	UNK (TLCALL *func3C)();
	UNK (TLCALL *func40)();
	UNK (TLCALL *func44)();
	UNK (TLCALL *func48)();
	UNK (TLCALL *func4C)();
	UNK (TLCALL *func50)();
	UNK (TLCALL *func54)();
	DWORD dummy58;
	ERR (TLCALL *smoothLuminanceVertically)(void* blockWithLength);
	DWORD dummy60[10];
	UNK (TLCALL *func88)();
	DWORD dummy8C;
	UNK (TLCALL *func90)();
	DWORD dummy94;
	UNK (TLCALL *func98)();
	UNK (TLCALL *func9C)();
	UNK (TLCALL *funcA0)();
	UNK (TLCALL *funcA4)();
	UNK (TLCALL *funcA8)();
	UNK (TLCALL *funcAC)();
	UNK (TLCALL *funcB0)();
	UNK (TLCALL *funcB4)();
	UNK (TLCALL *funcB8)();
	UNK (TLCALL *funcBC)();
	UNK (TLCALL *funcC0)();
	UNK (TLCALL *funcC4)();
	ZERO (TLCALL *setMatrix)(BYTE* matrix6elements);
	UNK (TLCALL *funcCC)();
	UNK (TLCALL *funcD0)();
	ERR (TLCALL *someFilterThing)(void* arg1, void* arg2, void* arg3);
	UNK (TLCALL *funcD8)();
	UNK (TLCALL *funcDC)();
	ZERO (TLCALL *forceLcdNoBgAndSomething)(void);
	UNK (TLCALL *funcE4)();
	UNK (TLCALL *funcE8)();
};

#define CAM (*((struct TearlessCamLib*)(TEARLESS_LIBS[12])))

#pragma pack (pop);
#ifdef __cplusplus
}
#endif

#endif

