/*************************************************************************
 * Copyright (c) 2004 Nick T Tate
 * 
 * This file is part of Tearless SDK.
 * 
 * Tearless SDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Tearless SDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Tearless SDK; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ************************************************************************/
/*
 * Header file for Tearless DPOF library (lib 11).
 *
 * Author: Nick T Tate 2003-09-07
 * 
 * $Id: tldpof.h 9 2004-10-20 20:31:52Z nicktt $
 */

#ifndef TEARLESS_DPOF_HEADER
#define TEARLESS_DPOF_HEADER

#include "tlcommon.h"

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack (push, 1);

// DPOF lib
struct TearlessDpofLib {
	ERR (TLCALL *dropPhotoInfoCaches)(void);
	ERR (TLCALL *writebackPhotoInfoCaches)(void);
	ulong (TLCALL *getNumOfPhotoFiles)(void);
	UNK (TLCALL *funcC)();
	UNK (TLCALL *func10)();
	UNK (TLCALL *func14)();
	UNK (TLCALL *func18)();
	UNK (TLCALL *func1C)();
	ERR (TLCALL *changePhotoFileDirNum)(WORD dirNum, WORD fileNum);
	UNK (TLCALL *func24)();
	UNK (TLCALL *func28)();
	UNK (TLCALL *func2C)();
	UNK (TLCALL *func30)();
	UNK (TLCALL *func34)();
	UNK (TLCALL *func38)();
	UNK (TLCALL *func3C)();
	UNK (TLCALL *func40)();
	UNK (TLCALL *func44)();
	UNK (TLCALL *func48)();
	UNK (TLCALL *func4C)();
	void (TLCALL *freeStructWithAutPrint)(void);
	UNK (TLCALL *func54)();
	UNK (TLCALL *func58)();
	UNK (TLCALL *func5C)();
	UNK (TLCALL *func60)();
	void (TLCALL *freeAutPrintMem)(void);
};

#define DPOF (*((struct TearlessDpofLib*)(TEARLESS_LIBS[11])))

#pragma pack (pop);
#ifdef __cplusplus
}
#endif

#endif

