/*************************************************************************
 * Copyright (c) 2004 Nick T Tate
 * 
 * This file is part of Tearless SDK.
 * 
 * Tearless SDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Tearless SDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Tearless SDK; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ************************************************************************/
/*
 * Header file for Tearless Photo Edit library (Lib 13).
 *
 * Author: Nick T Tate 2003-09-07
 * 
 * $Id: tledit.h 12 2004-10-21 11:51:11Z nicktt $
 */

#ifndef TEARLESS_EDIT_HEADER
#define TEARLESS_EDIT_HEADER

#include "tlcommon.h"

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack (push, 1);

// Edit lib
struct TearlessEditLib {

	/* NOTE: This will only rotate the given file. Any existing
	 * thumbnail file must be separately rotated.
	 * Angle is usually only supported in 90 degree increments.
	 */
	ERR (TLCALL *rotatePhoto)(char* fileName, WORD angle);
	UNK (TLCALL *func4)();
	UNK (TLCALL *func8)();
	UNK (TLCALL *funcC)();
};

#define EDIT (*((struct TearlessEditLib*)(TEARLESS_LIBS[13])))

#pragma pack (pop);
#ifdef __cplusplus
}
#endif

#endif

