/*************************************************************************
 * Copyright (c) 2004 Nick T Tate
 * 
 * This file is part of Tearless SDK.
 * 
 * Tearless SDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Tearless SDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Tearless SDK; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ************************************************************************/
/*
 * Header file for Tearless Font library (Lib 9).
 *
 * Author: Nick T Tate 2003-09-07
 * 
 * $Id: tlfont.h 9 2004-10-20 20:31:52Z nicktt $
 */

#ifndef TEARLESS_FONT_HEADER
#define TEARLESS_FONT_HEADER

#include "tlcommon.h"

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack (push, 1);

// Font lib
struct TearlessFontLib {
	/*
	 * If fgBitmapLinPtr is NULL, the default font will be used.
	 * This function calls GFX.setAsciiFont() with default size.
	 */
	ERR (TLCALL *setCustomAsciiFont)(DWORD fgBitmapLinPtr, DWORD bgBitmapLinPtr);

	/*
	 * If fgBitmapLinPtr is NULL, the default font will be used.
	 * This function calls GFX.setWideFont() with default size.
	 */
	ERR (TLCALL *setCustomWideFont)(DWORD fgBitmapLinPtr, DWORD bgBitmapLinPtr);
	ZERO (TLCALL *loadLocalizedTextFrom)(char* fileName);
	ERR (TLCALL *initLocalization)(void);
};

#define FONT (*((struct TearlessFontLib*)(TEARLESS_LIBS[9])))

#pragma pack (pop);
#ifdef __cplusplus
}
#endif

#endif

