/*************************************************************************
 * Copyright (c) 2004 Nick T Tate
 * 
 * This file is part of Tearless SDK.
 * 
 * Tearless SDK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Tearless SDK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Tearless SDK; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ************************************************************************/
/*
 * Header file for Tearless Memory library (Lib 4).
 *
 * Author: Nick T Tate 2003-09-07
 * 
 * $Id: tlmem.h 10 2004-10-21 08:18:24Z nicktt $
 */

#ifndef TEARLESS_MEM_HEADER
#define TEARLESS_MEM_HEADER

#include "tlcommon.h"

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack (push, 1);

// Memory lib (complete)
struct TearlessMemLib {
	void* (TLCALL *allocMem)(ulong byteSize);
	void* (TLCALL *allocArray)(ulong numElements, ulong elementSize);
	void* (TLCALL *reallocMem)(void* oldBlock, ulong newByteSize);
	ERR (TLCALL *freeMem)(void* memBlock);
	ulong (TLCALL *getAllocBlockSize)(void* memBlock);
};

#define MEM (*((struct TearlessMemLib*)(TEARLESS_LIBS[4])))

#pragma pack (pop);
#ifdef __cplusplus
}
#endif

#endif

